unit UHisto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, UComunes, math, ComCtrls;

type
  TForm3 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    cols    : array [0..3] of TColor;
    HCans   : array [0..3] of boolean;
    LocMat  : TMimag;
    HX,HY   : integer;
    Lienzo  : TCanvas;

    procedure canales();
    procedure sumas();
    procedure maximos();
    procedure dibuja();

  public
    { Public declarations }
    Histo  : array of array[0..4] of integer;
    HNiv   : integer;
    Maxs   : array [0..3] of integer;
    Maxx   : integer;
  end;

var
  Form3: TForm3;

implementation

uses Unit1;

{$R *.dfm}

procedure TForm3.FormCreate(Sender: TObject);
begin
  cols[0] := clRed;
  cols[1] := clGreen;
  cols[2] := clBlue;
  cols[3] := clBlack;

  HX      := Image1.Width;
  HY      := Image1.Height;
  Lienzo  := Image1.Canvas;
  Lienzo.Brush.Color := clSilver;
end;

// refrescar
procedure TForm3.Button1Click(Sender: TObject);
begin
  if (Form1.M1.tx = 0)
    then ShowMessage('No hay Datos para Procesar ...');

  if (Form1.M2.tx = 0)
    then LocMat := Form1.M1
    else LocMat := Form1.M2;

  canales();
  sumas();
  maximos();
  dibuja();
end;

procedure TForm3.canales();
begin
  Hcans[0] := CheckBox1.checked;
  Hcans[1] := CheckBox2.checked;
  Hcans[2] := CheckBox3.checked;
  Hcans[3] := CheckBox4.checked;
end;

procedure TForm3.sumas();
var
  kk, cc, x, y , tt  : integer;
  gris               : single;
begin
  if ComboBox1.ItemIndex = 0
    then HNiv := 256
    else HNiv := 512;

  // dimensiona
  SetLength(Histo,HNiv);

  // limpia listas
  for cc := 0 to 3 do if Hcans[cc] then
    for kk := 0 to Hniv - 1 do
      Histo[kk][cc] := 0;

  // cuenta
  if (Hniv = 256)
    then begin
      for cc := 0 to 2 do if Hcans[cc] then
         for y := _y1 to _y2 - 1 do
           for x := _x1 to _x2 - 1 do begin
             tt := ajusta(LocMat.dat[x][y][cc]);
             inc(Histo[tt][cc]);
           end;

      if HCans[3] then
         for y := _y1 to _y2 - 1 do
           for x := _x1 to _x2 - 1 do begin
             gris := (LocMat.dat[x][y][0]+LocMat.dat[x][y][1]+LocMat.dat[x][y][2])/3;
             tt := ajusta(gris);
             inc(Histo[tt][3]);
           end
    end
    else begin
      for cc := 0 to 2 do if Hcans[cc] then
         for y := _y1 to _y2 - 1 do
           for x := _x1 to _x2 - 1 do begin
             tt := ajusta2(2*LocMat.dat[x][y][cc]);
             inc(Histo[tt][cc]);
           end;

      if HCans[3] then
         for y := _y1 to _y2 - 1 do
           for x := _x1 to _x2 - 1 do begin
             gris := (LocMat.dat[x][y][0]+LocMat.dat[x][y][1]+LocMat.dat[x][y][2])/3;
             tt := ajusta(2*gris);
             inc(Histo[tt][3]);
           end
    end;

end;

// mximos
procedure TForm3.maximos();
var
  kk, cc, mm: integer;
begin
  // hiptesis
  for cc := 0 to 3 do if Hcans[cc]
    then maxs[cc] := Histo[0][cc]
    else maxs[cc] := 0;

  // correccin
  for cc := 0 to 3 do if Hcans[cc] then
    for kk := 1 to Hniv - 1 do begin
         mm := Histo[kk][cc];
         maxs[cc] := MAX(maxs[cc],mm);
       end;

  // Informe
  with StatusBar1 do
    for cc := 0 to 3 do if HCans[cc]
      then Panels[2*cc].Text := IntToStr(maxs[cc])
      else Panels[2*cc].Text := 'No Eval';
end;

// dibuja
procedure TForm3.dibuja();
const
  mar = 10;
var
  kk, cc, YY, elMax,paso : integer;
  facy                   : single;
begin
  if RadioGroup2.ItemIndex = 0 then begin
    elMax := maxs[0];
    for cc := 1 to 3 do
      elMax := MAX(elMax, maxs[cc]);

    for cc := 0 to 3 do
      maxs[cc] := elMax;
  end;

  // limpia el lienzo
  Lienzo.Rectangle(-1,-1,Hx+1,Hy+1);
  paso  := 512 div HNiv;

  if RadioGroup1.ItemIndex = 0
  then begin
    for cc := 0 to 3 do if HCans[cc] then begin
      Lienzo.Pen.Color := cols[cc];
      facy := (HY - 2*mar)/maxs[cc];
      YY   := ceil(facy*Histo[0][cc]);
      Lienzo.MoveTo(mar,HY - YY - mar);
      for kk := 1 to HNiv - 1 do begin
        YY   := ceil(facy*Histo[kk][cc]);
        Lienzo.LineTo(mar+paso*kk,HY - YY - mar);
      end;
    end
  end
  else begin
    for cc := 0 to 3 do if HCans[cc] then begin
      Lienzo.Pen.Color := cols[cc];
      facy := (HY - 2*mar)/LNXp1(maxs[cc]);
      YY   := ceil(facy*Histo[0][cc]);
      Lienzo.MoveTo(mar,HY - YY - mar);
      for kk := 1 to HNiv - 1 do begin
        YY   := ceil(facy*LNXp1(Histo[kk][cc]));
        Lienzo.LineTo(mar+paso*kk,HY - YY - mar);
      end;
    end;
  end;

  // Ejes
  Lienzo.Pen.Color := clWhite;
  Lienzo.MoveTo(mar-1   ,HY-mar+1);
  Lienzo.LineTo(Hx-mar-1,HY-mar+1);

  Lienzo.MoveTo(mar-1,mar-1);
  Lienzo.LineTo(mar-1,Hy-mar+1);
end;

end.
